package sun.java2d.loops;

import sun.java2d.SurfaceData;
import sun.java2d.SunGraphics2D;

public class DrawLine extends GraphicsPrimitive
{
    public static final String methodSignature;
    public static final int primTypeID;
    
    public static DrawLine locate(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        return (DrawLine)GraphicsPrimitiveMgr.locate(DrawLine.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    protected DrawLine(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        super(DrawLine.methodSignature, DrawLine.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    public DrawLine(long n, SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        super(n, DrawLine.methodSignature, DrawLine.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    public native void DrawLine(SunGraphics2D p0, SurfaceData p1, int p2, int p3, int p4, int p5);
    
    @Override
    public GraphicsPrimitive makePrimitive(SurfaceType obj, CompositeType obj2, SurfaceType surfaceType) {
        throw new InternalError("DrawLine not implemented for " + obj + " with " + obj2);
    }
    
    @Override
    public GraphicsPrimitive traceWrap() {
        return new DrawLine.TraceDrawLine(this);
    }
    
    static {
        methodSignature = "DrawLine(...)".toString();
        primTypeID = GraphicsPrimitive.makePrimTypeID();
    }
    
    private static class TraceDrawLine extends DrawLine
    {
        DrawLine target;
        
        public TraceDrawLine(DrawLine target) {
            super(target.getSourceType(), target.getCompositeType(), target.getDestType());
            this.target = target;
        }
        
        @Override
        public GraphicsPrimitive traceWrap() {
            return this;
        }
        
        @Override
        public void DrawLine(SunGraphics2D sunGraphics2D, SurfaceData surfaceData, int n, int n2, int n3, int n4) {
            GraphicsPrimitive.tracePrimitive(this.target);
            this.target.DrawLine(sunGraphics2D, surfaceData, n, n2, n3, n4);
        }
    }
}
